/*
 * The Hello Tcl command.
 *    This demo could be implemented using TCL only but we use a code plugin to demonstrate the method
 */


#ifdef WIN32
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

#define __WIN32__
#endif

#include <tcl.h>


static int  HelloCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp, int argc, char *argv[]));

#ifdef WIN32

DLLIMPORT Tcl_Command Tcl_CreateCommand (Tcl_Interp*, CONST char *, Tcl_CmdProc*, ClientData , Tcl_CmdDeleteProc*);
DLLIMPORT int         Tcl_PkgProvide    (Tcl_Interp*, CONST char *, CONST char *);

DLLEXPORT Hello_init;
    
BOOL WINAPI DllMain(HANDLE hModule, DWORD dwFunction, LPVOID lpNot) {return TRUE;}
#endif


/*
 * Hello Cmd --
 *
 * Results:
 *  none
 *
 */
 
static int Hello_Cmd(ClientData data, Tcl_Interp *interp, int argc, char *argv[])
{
    int rc;

    printf ("Hello speaking\n");

    printf("You have %d args\n", argc);

    if (argc == 2) {
           printf ("Hello received message: %s\n", argv[1]);
           rc = TCL_OK;
    } else {
        rc = TCL_ERROR;
    }
    
    return rc;
}

/*
 * Hello_Init --
 *  Initialize the Tcl Hello facility.
 *
 * Results:
 *  TCL_OK.
 *
 * Side Effects:
 *  None.
 */
 
int Hello_Init(Tcl_Interp *interp)
{

    Tcl_CreateCommand(interp, "Hello", (Tcl_CmdProc*) Hello_Cmd,  NULL, NULL);
    Tcl_PkgProvide(interp, "Hello", "1.0");
    return TCL_OK;
}
